<?
if (!defined("B_PROLOG_INCLUDED") || B_PROLOG_INCLUDED !== true) die();
$this->setFrameMode(false);

use Bitrix\Main\Loader,
    Bitrix\Main\Mail\Event,
    Bitrix\Iblock\ElementTable,
    Bitrix\Catalog\Model\Price,
    Bitrix\Iblock\PropertyTable,
    Bitrix\Iblock\PropertyEnumerationTable,
    Bitrix\Main\UserTable;

Loader::includeModule('iblock');
Loader::includeModule('catalog');

$arResult['EDIT_VALUES'] = [];
$arResult['ERROR'] = [];

if ($USER->IsAuthorized()) {
    $arResult['USER'] = UserTable::getList([
        'filter' => [
            'ID' => $USER->GetID()
        ],
        'select' => [
            '*'
        ]
    ])->fetch();
} else {
    LocalRedirect($arParams['LOCAL_REDIRECT']);
    exit();
}



// Получаем все разделы инфоблока для select
$arResult['IBLOCK_SECTIONS'] = \Bitrix\Iblock\SectionTable::getList(array(
    // todo 6 обработка разделов + script.js
    'filter' => array(
        'IBLOCK_ID' => $arParams['IBLOCK_ID'],
        'DEPTH_LEVEL' => 1,
    ),
    'order' => array(
        'NAME' => 'ASC'
    ),
    'select' => array(
        'ID', 'NAME'
    ),
))->fetchAll();
// end Получаем все разделы инфоблока для select
// Поиск подразделов у выбранного раздела
if (isset($_POST['SECTION_PARENT_ID'])) {
    $sectionId = $_POST['SECTION_PARENT_ID'];
    // Получаем подразделы выбранного раздела
    $arResult['SUB_SECTIONS_LIST'] = \Bitrix\Iblock\SectionTable::getList(array(
        'filter' => array(
            'IBLOCK_ID' => $arParams['IBLOCK_ID'],
            '=IBLOCK_SECTION_ID' => $sectionId,
        ),
        'order' => array(
            'NAME' => 'ASC'
        ),
        'select' => array(
            'ID', 'NAME'
        ),
    ))->fetchAll();
}
// end Поиск подразделов у выбранного раздела


// Получаем все свойства
$rsProperties = PropertyTable::getList([
    'filter' => [
        '=IBLOCK_ID' => $arParams['IBLOCK_ID'],
    ],
    'select' => [
        'ID',
        'NAME',
        'CODE',
        'PROPERTY_TYPE',
        'MULTIPLE'
    ],
]);
while ($arProperty = $rsProperties->fetch()) {
    $arResult['PROPERTIES'][$arProperty['CODE']][$arProperty['ID']] = $arProperty;
    // Если свойство - это множественный список
    if ($arProperty['PROPERTY_TYPE'] == "L" && $arProperty['MULTIPLE'] == "Y") {
        // Получение значений множественного свойства
        $enumerationValues = PropertyEnumerationTable::getList([
            'filter' => [
                'PROPERTY_ID' => $arProperty['ID']
            ],
            'select' => [
                'ID',
                'VALUE',
            ]
        ])->fetchAll();
        // Добавление значений множественного свойства в массив свойств
        $arResult['PROPERTIES'][$arProperty['CODE']][$arProperty['ID']]['ENUM_VALUES'] = $enumerationValues;
    }
}
// end Получаем все выбранные в параметрах свойства

if (!empty($_REQUEST['EDIT_ELEMENT'])) {
// Получаем данные элемента
    $arResult['HIDE_EDIT_PROPS'] = [
        'Yes'
    ];
    $APPLICATION->SetTitle("Редактирование объявления");
    $rsElements = ElementTable::getList([
        'filter' => [
            'IBLOCK_ID' => $arParams['IBLOCK_ID'],
            'ID' => $_REQUEST['EDIT_ELEMENT']
        ],
        'select' => [
            'ID',
            'NAME',
            'IBLOCK_SECTION_ID',
            'DETAIL_TEXT',
            'CREATED_BY'
        ]
    ]);

    if ($arElement = $rsElements->fetch()) {
        // Проверяем, имеет ли пользователь право на редактирование
        if ($arElement['CREATED_BY'] !== $arResult['USER']['ID']) {
            LocalRedirect($arParams['LOCAL_REDIRECT']);
            exit;
        }

        // Добавляем данные элемента
        $arResult['EDIT_VALUES'] = $arElement;

        // todo 6 Получаем информацию о разделе по его ID
        if (!isset($_POST['SECTION_PARENT_ID'])) {
            $rsSection = \CIBlockSection::GetByID($arResult['EDIT_VALUES']['IBLOCK_SECTION_ID']);
            if ($arSection = $rsSection->GetNext()) {
                // Если раздел найден, получаем ID его родителя
                $arResult['EDIT_VALUES']['PARENT_SECTION'] = $arSection['IBLOCK_SECTION_ID'];
                // Зная родителя получаем всех потомков
                $arResult['SUB_SECTIONS_LIST'] = \Bitrix\Iblock\SectionTable::getList(array(
                    'filter' => array(
                        'IBLOCK_ID' => $arParams['IBLOCK_ID'],
                        '=IBLOCK_SECTION_ID' => $arResult['EDIT_VALUES']['PARENT_SECTION'],
                    ),
                    'order' => array(
                        'NAME' => 'ASC'
                    ),
                    'select' => array(
                        'ID', 'NAME'
                    ),
                ))->fetchAll();
            }
        }
        // Получаем информацию о разделе по его ID

        // Получаем значения свойств для этого элемента
        foreach ($arResult['PROPERTIES'] as $arProperty) {
            // Перебор всех свойств инфоблока из готового массива $arResult['PROPERTIES']
            foreach ($arProperty as $arPropertyData) {
                $rsPropertyValues = \CIBlockElement::getProperty(
                    $arParams['IBLOCK_ID'],
                    $arElement['ID'],
                    array(),
                    array('ID' => $arPropertyData['ID'])
                );

                while ($arPropertyValue = $rsPropertyValues->fetch()) {
                    // Находим и заполняем значения свойств в  $arResult['EDIT_VALUES'][КОД СВОЙСТВА]
                    if ($arPropertyData['MULTIPLE'] === 'Y') {
                        if (!isset($arResult['EDIT_VALUES'][$arPropertyData['CODE']])) {
                            $arResult['EDIT_VALUES'][$arPropertyData['CODE']] = array();
                        }
                        $arResult['EDIT_VALUES'][$arPropertyData['CODE']][] = $arPropertyValue['VALUE'];
                    } else {
                        $arResult['EDIT_VALUES'][$arPropertyData['CODE']] = $arPropertyValue['VALUE'];
                    }
                }
            }
        }
        // Получаем цену товара
        $priceIterator = Price::getList([
            'filter' => [
                '=PRODUCT_ID' => $arElement['ID'], // ID товара
                '=CATALOG_GROUP_ID' => '1' // ID типа цены
            ]
        ]);

        if ($price = $priceIterator->fetch()) {
            $arResult['EDIT_VALUES']['PRICE'] = $price;
        }
    }
    // Фотографии
    // todo 6 добавили фотографии
    foreach ($arResult['EDIT_VALUES']['MORE_PHOTO'] as $PHOTOS) {
        $arResult['EDIT_VALUES']['PHOTOS'][] = CFile::GetPath($PHOTOS);
    }
}


// POST формы
$arResult['ERROR'] = array();
if (
    (!empty($_REQUEST['NAME'])) &&
    (!empty($_REQUEST['sessid']))
) {
    $el = new CIBlockElement;

    // Заполняем свойства кроме фоток
    foreach ($arResult['PROPERTIES'] as $k => $PostProperty) {
        // в $k CODE свойства - получаем выше на массив $arResult['PROPERTIES']
        if ($k !== 'MORE_PHOTO') {
            $postedProperty[$k] = $_POST[$k];
        }
    }
    // end Заполняем свойства кроме фоток
    // Заполняем фотографии из $_FILES
    $arMorePhoto = array();
    if (!empty($_FILES['MORE_PHOTO']['tmp_name']) && is_array($_FILES['MORE_PHOTO']['tmp_name'])) {
        foreach ($_FILES['MORE_PHOTO']['tmp_name'] as $key => $tmpName) {
            if (!empty($tmpName)) {
                $arMorePhoto['n' . $key] = array(
                    'VALUE' => CFile::MakeFileArray(
                        $_FILES['MORE_PHOTO']['tmp_name'][$key],
                        $_FILES['MORE_PHOTO']['type'][$key],
                        $_FILES['MORE_PHOTO']['name'][$key]
                    ),
                    'NAME' => $_FILES['MORE_PHOTO']['name'][$key]
                );
            }
        }
    }
    foreach ($arMorePhoto as $k => $reName) {
        $arMorePhoto[$k]['VALUE']['name'] = $arMorePhoto[$k]['NAME'];
    }
    $postedProperty['MORE_PHOTO'] = $arMorePhoto;
    // end Заполняем фотографии


    $arFields = array(
        "IBLOCK_ID" => $arParams['IBLOCK_ID'],
        "NAME" => strip_tags($_REQUEST['NAME']),
        'CREATED_BY' => $arResult['USER']['ID'],
        'ACTIVE' => 'N',
        "DETAIL_TEXT" => strip_tags($_REQUEST['DETAIL_TEXT']),
        "IBLOCK_SECTION_ID" => strip_tags($_REQUEST['IBLOCK_SECTION']),
        "PROPERTY_VALUES" => $postedProperty,
    );

    if (!empty($_REQUEST['EDIT_ELEMENT'])) { // Обновление элемента
        if ($el->Update($_REQUEST['EDIT_ELEMENT'], $arFields)) {
            $updatePrice = \Bitrix\Catalog\Model\Price::update(
                $arResult['EDIT_VALUES']['PRICE']['ID'], // Получили выше в методе $priceIterator = Price::getList
                array(
                    'PRODUCT_ID' => $_REQUEST['EDIT_ELEMENT'],
                    'CATALOG_GROUP_ID' => 1,
                    'PRICE' => strip_tags($_REQUEST['PRICE']),
                    'CURRENCY' => 'RUB',
                )
            );
            Event::send(array(
                'EVENT_NAME' => 'MODERATE_BULLETIN_NEW_ITEM',
                'LID' => 's2',
                'C_FIELDS' => array(
                    'ELEMENT_ID' => $_REQUEST['EDIT_ELEMENT']
                ),
            ));
            // Отправляем пользователя в список его объявлений
             LocalRedirect($arParams['LOCAL_REDIRECT']);
        }
    } else { // Добавление элемента
        if ($NewElementId = $el->Add($arFields)) {
            // Превращаем элемент в товар
            $makeProduct = \Bitrix\Catalog\Model\Product::add([
                'external_fields' => [
                    'IBLOCK_ID' => $arParams['IBLOCK_ID'], // необязательный ключ, минус 1 запрос к базе
                ],
                'fields' => [
                    'ID' => $NewElementId,
                    'VAT_INCLUDED' => 'Y'
                ],
            ]);
            // Добавляем цену к товару
            $addPrice = \Bitrix\Catalog\Model\Price::add([
                'fields' => [
                    'PRODUCT_ID' => $NewElementId,
                    'CATALOG_GROUP_ID' => 1,
                    'PRICE' => strip_tags($_REQUEST['PRICE']),
                    'CURRENCY' => 'RUB',
                ]
            ]);
            // Шлем письмо модератору
            Event::send(array(
                'EVENT_NAME' => 'MODERATE_BULLETIN_NEW_ITEM',
                'LID' => 's2',
                'C_FIELDS' => array(
                    'ELEMENT_ID' => $NewElementId
                ),
            ));
            // Отправляем пользователя в список его объявлений
             LocalRedirect($arParams['LOCAL_REDIRECT']);
        } else {
            $arResult['ERRORS'][] = $el->LAST_ERROR;
        }
    }
}

$this->includeComponentTemplate();
?>