<?
if (!defined("B_PROLOG_INCLUDED") || B_PROLOG_INCLUDED !== true) die();
$this->setFrameMode(false);

use Bitrix\Main\Loader;
use Bitrix\Main\Mail\Event;
use Bitrix\Iblock\ElementTable;
use Bitrix\Catalog\Model\Price;
use Bitrix\Iblock\PropertyTable;
use Bitrix\Iblock\PropertyEnumerationTable;
use Bitrix\Main\UserTable;

Loader::includeModule('iblock');
Loader::includeModule('catalog');

$arResult['EDIT_VALUES'] = [];
$arResult['ERROR'] = [];

if ($USER->IsAuthorized()) {
    $arResult['USER'] = UserTable::getList([
        'filter' => [
            'ID' => $USER->GetID()
        ],
        'select' => [
            '*'
        ]
    ])->fetch();
} else {
    LocalRedirect('/bulletinboard/personal/');
    exit();
}


// Получаем все разделы инфоблока для select
$arResult['IBLOCK_SECTIONS'] = \Bitrix\Iblock\SectionTable::getList(array(
    'filter' => array(
        'IBLOCK_ID' => $arParams['IBLOCK_ID'],
        'DEPTH_LEVEL' => 2,
    ),
    'order' => array(
        'NAME' => 'ASC'
    ),
    'select' => array(
        'ID', 'NAME'
    ),
))->fetchAll();
// end Получаем все разделы инфоблока для select

// Получаем все выбранные в параметрах свойства
$properties = PropertyTable::getList([
    'filter' => [
        '=IBLOCK_ID' => $arParams['IBLOCK_ID'],
        '=ID' => $arParams['SHOW_PROPERTIES_ID']
    ],
    'select' => [
        '*'
    ],
    'order' => [
        'SORT' => 'ASC'
    ]
]);
while ($property = $properties->fetch()) {
    $arResult['SHOW_PROPERTIES'][$property['ID']] = $property;
    // Если свойство - это множественный список
    if ($property['PROPERTY_TYPE'] == "L" && $property['MULTIPLE'] == "Y") {
        // Получение значений свойства
        $enumerationValues = PropertyEnumerationTable::getList([
            'filter' => [
                'PROPERTY_ID' => $property['ID']
            ],
            'select' => [
                'ID',
                'VALUE',
            ]
        ])->fetchAll();
        // Добавление значений свойства в массив свойств
        $arResult['SHOW_PROPERTIES'][$property['ID']]['ENUM_VALUES'] = $enumerationValues;
    }
}
// end Получаем все выбранные в параметрах свойства


if (!empty($_REQUEST['EDIT_ELEMENT'])) {
// Получаем данные элемента
    $rsElements = ElementTable::getList([
        'filter' => [
            'IBLOCK_ID' => $arParams['IBLOCK_ID'],
            'ID' => $_REQUEST['EDIT_ELEMENT']
        ],
        'select' => [
            'ID',
            'NAME',
            'IBLOCK_SECTION_ID',
            'DETAIL_TEXT',
            'CREATED_BY'
        ]
    ]);

    if ($arElement = $rsElements->fetch()) {

        // Проверяем, имеет ли пользователь право на редактирование
        if ($arElement['CREATED_BY'] !== $arResult['USER']['ID']) {
            LocalRedirect('/');
            exit;
        }

        // Добавляем остальные данные элемента
        $arResult['EDIT_VALUES'] = $arElement;

        // Получаем все свойства элемента
        // TODO это не надо есть выше
        $rsProperties = PropertyTable::getList([
            'filter' => [
                'IBLOCK_ID' => $arParams['IBLOCK_ID'], // Учитываем ID инфоблока
                'ACTIVE' => 'Y'
            ]
        ]);
      
        while ($arProperty = $rsProperties->fetch()) {
            // Получаем значения свойств для данного элемента
            // TODO скорректировать возможно не нужно
            $rsPropertyValues = \CIBlockElement::getProperty(
                $arParams['IBLOCK_ID'],
                $arElement['ID'],
                array(),
                array('ID' => $arProperty['ID'])
            );

            while ($arPropertyValue = $rsPropertyValues->fetch()) {
                if ($arProperty['MULTIPLE'] === 'Y') {
                    if (!isset($arResult['EDIT_VALUES'][$arProperty['CODE']])) {
                        $arResult['EDIT_VALUES'][$arProperty['CODE']] = array();
                    }
                    $arResult['EDIT_VALUES'][$arProperty['CODE']][] = $arPropertyValue['VALUE'];
                } else {
                    $arResult['EDIT_VALUES'][$arProperty['CODE']] = $arPropertyValue['VALUE'];
                }
            }
        }

        // Получаем цену товара
        $priceIterator = Price::getList([
            'filter' => [
                '=PRODUCT_ID' => $arElement['ID'], // ID товара
                '=CATALOG_GROUP_ID' => '1' // ID типа цены
            ]
        ]);

        if ($price = $priceIterator->fetch()) {
            $arResult['EDIT_VALUES']['PRICE'] = $price;
        }



    }
}



// POST формы
$arResult['ERROR'] = array();
if (
    (!empty($_REQUEST['NAME'])) &&
    (!empty($_REQUEST['sessid']))
) {
    $el = new CIBlockElement;

    // Заполняем свойства кроме фоток
    foreach ($arResult['SHOW_PROPERTIES'] as $PostProperty) {
        if ($PostProperty['CODE'] !== 'MORE_PHOTO') {
            $postedProperty[$PostProperty['CODE']] = $_POST[$PostProperty['CODE']];
        }
    }
    // end Заполняем свойства кроме фоток
    // Заполняем фотографии из $_FILES
    $arMorePhoto = array();
    if (!empty($_FILES['MORE_PHOTO']['tmp_name']) && is_array($_FILES['MORE_PHOTO']['tmp_name'])) {
        foreach ($_FILES['MORE_PHOTO']['tmp_name'] as $key => $tmpName) {
            if (!empty($tmpName)) {
                $arMorePhoto['n' . $key] = array(
                    'VALUE' => CFile::MakeFileArray(
                        $_FILES['MORE_PHOTO']['tmp_name'][$key],
                        $_FILES['MORE_PHOTO']['type'][$key],
                        $_FILES['MORE_PHOTO']['name'][$key]
                    ),
                    'NAME' => $_FILES['MORE_PHOTO']['name'][$key]
                );
            }
        }
    }
    foreach ($arMorePhoto as $k => $reName) {
        $arMorePhoto[$k]['VALUE']['name'] = $arMorePhoto[$k]['NAME'];
    }
    $postedProperty['MORE_PHOTO'] = $arMorePhoto;
    // end Заполняем фотографии





    $arFields = array(
        "IBLOCK_ID" => $arParams['IBLOCK_ID'],
        "NAME" => strip_tags($_REQUEST['NAME']),
        'CREATED_BY' => $arResult['USER']['ID'],
        'ACTIVE' => 'N',
        "DETAIL_TEXT" => strip_tags($_REQUEST['DETAIL_TEXT']),
        "IBLOCK_SECTION_ID" => strip_tags($_REQUEST['IBLOCK_SECTION']),
        "PROPERTY_VALUES" => $postedProperty,
    );

    if (!empty($_REQUEST['EDIT_ELEMENT'])) { // Обновление элемента
        if ($el->Update($_REQUEST['EDIT_ELEMENT'], $arFields)) {
            $updatePrice = \Bitrix\Catalog\Model\Price::update(
                $arResult['EDIT_VALUES']['PRICE']['ID'], // Получили выше в методе $priceIterator = Price::getList
                array(
                    'PRODUCT_ID' => $_REQUEST['EDIT_ELEMENT'],
                    'CATALOG_GROUP_ID' => 1,
                    'PRICE' => strip_tags($_REQUEST['PRICE']),
                    'CURRENCY' => 'RUB',
                )
            );
            Event::send(array(
                'EVENT_NAME' => 'MODERATE_BULLETIN_NEW_ITEM',
                'LID' => 's2',
                'C_FIELDS' => array(
                    'ELEMENT_ID' => $_REQUEST['EDIT_ELEMENT']
                ),
            ));
            // Отправляем пользователя в список его объявлений
            // LocalRedirect('/');
        }
    } else { // Добавление элемента
        if ($NewElementId = $el->Add($arFields)) {
            // Превращаем элемент в товар
            $makeProduct = \Bitrix\Catalog\Model\Product::add([
                'external_fields' => [
                    'IBLOCK_ID' => $arParams['IBLOCK_ID'], // необязательный ключ, минус 1 запрос к базе
                ],
                'fields' => [
                    'ID' => $NewElementId,
                    'VAT_INCLUDED' => 'Y'
                ],
            ]);
            // Добавляем цену к товару
            $addPrice = \Bitrix\Catalog\Model\Price::add([
                'fields' => [
                    'PRODUCT_ID' => $NewElementId,
                    'CATALOG_GROUP_ID' => 1,
                    'PRICE' => strip_tags($_REQUEST['PRICE']),
                    'CURRENCY' => 'RUB',
                ]
            ]);
            // Шлем письмо модератору
            Event::send(array(
                'EVENT_NAME' => 'MODERATE_BULLETIN_NEW_ITEM',
                'LID' => 's2',
                'C_FIELDS' => array(
                    'ELEMENT_ID' => $NewElementId
                ),
            ));
            // Отправляем пользователя в список его объявлений
            // LocalRedirect('/');
        } else {
            $arResult['ERRORS'][] = $el->LAST_ERROR;
        }
    }
}

$this->includeComponentTemplate();

/*
TODO Пример добавления и обновления с D7, работает через одно место, оставляю комментом чисто для общего развития

use Bitrix\Iblock\ElementTable; // Это в самый вверх, не подключаем в блоке if

// Добавление элемента инфоблока
       $result = ElementTable::add($fields);
         if ($result->isSuccess()) {
             $elementId = $result->getId();
             echo "Элемент успешно добавлен. ID: $elementId";
         } else {
             $errors = $result->getErrors();
             foreach ($errors as $error) {
                 echo "Ошибка при добавлении элемента: " . $error->getMessage();
             }
         }

// Обновление элемента инфоблока
         $result = ElementTable::update($elementId, $fields);

         if ($result->isSuccess()) {
             echo "Элемент успешно обновлен.";
         } else {
             $errors = $result->getErrors();
             foreach ($errors as $error) {
                 echo "Ошибка при обновлении элемента: " . $error->getMessage();
             }
         }
  */
?>